1 # SPDX-License-Identifier: GPL-2.0+
10 # To see a list of typical targets execute "make help"
11 # More info can be located in ./README
12 # Comments in this file are targeted only to the developer, do not
13 # expect to learn how to build the kernel reading this file.
15 # Do not use make's built-in rules and variables
16 # (this increases performance and avoids hard-to-debug behaviour)
19 # Determine target architecture for the sandbox
20 include include/host_arch.h
21 ifeq ("", "$(CROSS_COMPILE)")
22 MK_ARCH="${shell uname -m}"
24 MK_ARCH="${shell echo $(CROSS_COMPILE) | sed -n 's/^\s*\([^\/]*\/\)*\([^-]*\)-\S*/\2/p'}"
27 ifeq ("x86_64", $(MK_ARCH))
28 export HOST_ARCH=$(HOST_ARCH_X86_64)
29 else ifneq (,$(findstring $(MK_ARCH), "i386" "i486" "i586" "i686"))
30 export HOST_ARCH=$(HOST_ARCH_X86)
31 else ifneq (,$(findstring $(MK_ARCH), "aarch64" "armv8l"))
32 export HOST_ARCH=$(HOST_ARCH_AARCH64)
33 else ifneq (,$(findstring $(MK_ARCH), "arm" "armv7" "armv7l"))
34 export HOST_ARCH=$(HOST_ARCH_ARM)
35 else ifeq ("riscv32", $(MK_ARCH))
36 export HOST_ARCH=$(HOST_ARCH_RISCV32)
37 else ifeq ("riscv64", $(MK_ARCH))
38 export HOST_ARCH=$(HOST_ARCH_RISCV64)
42 # Avoid funny character set dependencies
46 export LC_COLLATE LC_NUMERIC
48 # Avoid interference with shell env settings
51 # We are using a recursive build, so we need to do a little thinking
52 # to get the ordering right.
54 # Most importantly: sub-Makefiles should only ever modify files in
55 # their own directory. If in some directory we have a dependency on
56 # a file in another dir (which doesn't happen often, but it's often
57 # unavoidable when linking the built-in.o targets which finally
58 # turn into vmlinux), we will call a sub make in that other dir, and
59 # after that we are sure that everything which is in that other dir
62 # The only cases where we need to modify files which have global
63 # effects are thus separated out and done before the recursive
64 # descending is started. They are now explicitly listed as the
68 # ---------------------------------------------------------------------------
70 # Normally, we echo the whole command before executing it. By making
71 # that echo $($(quiet)$(cmd)), we now have the possibility to set
72 # $(quiet) to choose other forms of output instead, e.g.
74 # quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
75 # cmd_cc_o_c = $(CC) $(c_flags) -c -o $@ $<
77 # If $(quiet) is empty, the whole command will be printed.
78 # If it is set to "quiet_", only the short version will be printed.
79 # If it is set to "silent_", nothing will be printed at all, since
80 # the variable $(silent_cmd_cc_o_c) doesn't exist.
82 # A simple variant is to prefix commands with $(Q) - that's useful
83 # for commands that shall be hidden in non-verbose mode.
87 # If KBUILD_VERBOSE equals 0 then the above command will be hidden.
88 # If KBUILD_VERBOSE equals 1 then the above command is displayed.
90 # To put more focus on warnings, be less verbose as default
91 # Use 'make V=1' to see the full commands
93 ifeq ("$(origin V)", "command line")
100 ifeq ($(KBUILD_VERBOSE),1)
108 # If the user is running make -s (silent mode), suppress echoing of
111 ifneq ($(filter 4.%,$(MAKE_VERSION)),) # make-4
112 ifneq ($(filter %s ,$(firstword x$(MAKEFLAGS))),)
116 ifneq ($(filter s% -s%,$(MAKEFLAGS)),)
121 export quiet Q KBUILD_VERBOSE
123 # kbuild supports saving output files in a separate directory.
124 # To locate output files in a separate directory two syntaxes are supported.
125 # In both cases the working directory must be the root of the kernel src.
127 # Use "make O=dir/to/store/output/files/"
129 # 2) Set KBUILD_OUTPUT
130 # Set the environment variable KBUILD_OUTPUT to point to the directory
131 # where the output files shall be placed.
132 # export KBUILD_OUTPUT=dir/to/store/output/files/
135 # The O= assignment takes precedence over the KBUILD_OUTPUT environment
138 # KBUILD_SRC is set on invocation of make in OBJ directory
139 # KBUILD_SRC is not intended to be used by the regular user (for now)
140 ifeq ($(KBUILD_SRC),)
142 # OK, Make called in directory where kernel src resides
143 # Do we want to locate output files in a separate directory?
144 ifeq ("$(origin O)", "command line")
145 KBUILD_OUTPUT := $(O)
148 # That's our default target when none is given on the command line
152 # Cancel implicit rules on top Makefile
153 $(CURDIR)/Makefile Makefile: ;
155 ifneq ($(KBUILD_OUTPUT),)
156 # Invoke a second make in the output directory, passing relevant variables
157 # check that the output directory actually exists
158 saved-output := $(KBUILD_OUTPUT)
159 KBUILD_OUTPUT := $(shell mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) \
161 $(if $(KBUILD_OUTPUT),, \
162 $(error failed to create output directory "$(saved-output)"))
164 # Look for make include files relative to root of kernel src
166 # This does not become effective immediately because MAKEFLAGS is re-parsed
167 # once after the Makefile is read. It is OK since we are going to invoke
169 MAKEFLAGS += --include-dir=$(CURDIR)
171 PHONY += $(MAKECMDGOALS) sub-make
173 $(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
177 $(Q)$(MAKE) -C $(KBUILD_OUTPUT) KBUILD_SRC=$(CURDIR) \
178 -f $(CURDIR)/Makefile $(filter-out _all sub-make,$(MAKECMDGOALS))
180 # Leave processing to above invocation of make
182 endif # ifneq ($(KBUILD_OUTPUT),)
183 endif # ifeq ($(KBUILD_SRC),)
185 # We process the rest of the Makefile if this is the final invocation of make
186 ifeq ($(skip-makefile),)
188 # Do not print "Entering directory ...",
189 # but we want to display it when entering to the output directory
190 # so that IDEs/editors are able to understand relative filenames.
191 MAKEFLAGS += --no-print-directory
193 # Call a source code checker (by default, "sparse") as part of the
196 # Use 'make C=1' to enable checking of only re-compiled files.
197 # Use 'make C=2' to enable checking of *all* source files, regardless
198 # of whether they are re-compiled or not.
200 # See the file "doc/sparse.txt" for more details, including
201 # where to get the "sparse" utility.
203 ifeq ("$(origin C)", "command line")
204 KBUILD_CHECKSRC = $(C)
206 ifndef KBUILD_CHECKSRC
210 # Use make M=dir to specify directory of external module to build
211 # Old syntax make ... SUBDIRS=$PWD is still supported
212 # Setting the environment variable KBUILD_EXTMOD take precedence
214 KBUILD_EXTMOD ?= $(SUBDIRS)
217 ifeq ("$(origin M)", "command line")
218 KBUILD_EXTMOD := $(M)
221 # If building an external module we do not care about the all: rule
222 # but instead _all depend on modules
224 ifeq ($(KBUILD_EXTMOD),)
230 ifeq ($(KBUILD_SRC),)
231 # building in the source tree
234 ifeq ($(KBUILD_SRC)/,$(dir $(CURDIR)))
235 # building in a subdirectory of the source tree
238 srctree := $(KBUILD_SRC)
245 VPATH := $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))
247 export srctree objtree VPATH
249 # Make sure CDPATH settings don't interfere
252 #########################################################################
254 HOSTARCH := $(shell uname -m | \
256 -e s/sun4u/sparc64/ \
259 -e s/ppc64/powerpc/ \
261 -e s/macppc/powerpc/\
264 HOSTOS := $(shell uname -s | tr '[:upper:]' '[:lower:]' | \
265 sed -e 's/\(cygwin\).*/cygwin/')
267 export HOSTARCH HOSTOS
269 #########################################################################
271 # set default to nothing for native builds
272 ifeq ($(HOSTARCH),$(ARCH))
276 KCONFIG_CONFIG ?= .config
277 export KCONFIG_CONFIG
279 # SHELL used by kbuild
280 CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
281 else if [ -x /bin/bash ]; then echo /bin/bash; \
282 else echo sh; fi ; fi)
284 HOST_LFS_CFLAGS := $(shell getconf LFS_CFLAGS 2>/dev/null)
285 HOST_LFS_LDFLAGS := $(shell getconf LFS_LDFLAGS 2>/dev/null)
286 HOST_LFS_LIBS := $(shell getconf LFS_LIBS 2>/dev/null)
290 KBUILD_HOSTCFLAGS := -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer \
291 $(HOST_LFS_CFLAGS) $(HOSTCFLAGS)
292 KBUILD_HOSTCXXFLAGS := -O2 $(HOST_LFS_CFLAGS) $(HOSTCXXFLAGS)
293 KBUILD_HOSTLDFLAGS := $(HOST_LFS_LDFLAGS) $(HOSTLDFLAGS)
294 KBUILD_HOSTLDLIBS := $(HOST_LFS_LIBS) $(HOSTLDLIBS)
296 # With the move to GCC 6, we have implicitly upgraded our language
297 # standard to GNU11 (see https://gcc.gnu.org/gcc-5/porting_to.html).
298 # Some Linux distributions (including RHEL7, SLES13, Debian 8) still
299 # have older compilers as their default, so we make it explicit for
300 # these that our host tools are GNU11 (i.e. C11 w/ GNU extensions).
301 CSTD_FLAG := -std=gnu11
302 KBUILD_HOSTCFLAGS += $(CSTD_FLAG)
304 ifeq ($(HOSTOS),cygwin)
305 KBUILD_HOSTCFLAGS += -ansi
308 # Mac OS X / Darwin's C preprocessor is Apple specific. It
309 # generates numerous errors and warnings. We want to bypass it
310 # and use GNU C's cpp. To do this we pass the -traditional-cpp
311 # option to the compiler. Note that the -traditional-cpp flag
312 # DOES NOT have the same semantics as GNU C's flag, all it does
313 # is invoke the GNU preprocessor in stock ANSI/ISO C fashion.
315 # Apple's linker is similar, thanks to the new 2 stage linking
316 # multiple symbol definitions are treated as errors, hence the
317 # -multiply_defined suppress option to turn off this error.
319 ifeq ($(HOSTOS),darwin)
320 # get major and minor product version (e.g. '10' and '6' for Snow Leopard)
321 DARWIN_MAJOR_VERSION = $(shell sw_vers -productVersion | cut -f 1 -d '.')
322 DARWIN_MINOR_VERSION = $(shell sw_vers -productVersion | cut -f 2 -d '.')
324 os_x_before = $(shell if [ $(DARWIN_MAJOR_VERSION) -le $(1) -a \
325 $(DARWIN_MINOR_VERSION) -le $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
327 os_x_after = $(shell if [ $(DARWIN_MAJOR_VERSION) -ge $(1) -a \
328 $(DARWIN_MINOR_VERSION) -ge $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
330 # Snow Leopards build environment has no longer restrictions as described above
331 HOSTCC = $(call os_x_before, 10, 5, "cc", "gcc")
332 KBUILD_HOSTCFLAGS += $(call os_x_before, 10, 4, "-traditional-cpp")
333 KBUILD_HOSTLDFLAGS += $(call os_x_before, 10, 5, "-multiply_defined suppress")
335 # macOS Mojave (10.14.X)
336 # Undefined symbols for architecture x86_64: "_PyArg_ParseTuple"
337 KBUILD_HOSTLDFLAGS += $(call os_x_after, 10, 14, "-lpython -dynamclib", "")
340 # Decide whether to build built-in, modular, or both.
341 # Normally, just do built-in.
346 # If we have only "make modules", don't compile built-in objects.
347 # When we're building modules with modversions, we need to consider
348 # the built-in objects during the descend as well, in order to
349 # make sure the checksums are up to date before we record them.
351 ifeq ($(MAKECMDGOALS),modules)
352 KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
355 # If we have "make <whatever> modules", compile modules
356 # in addition to whatever we do anyway.
357 # Just "make" or "make all" shall build modules as well
359 # U-Boot does not need modules
360 #ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
361 # KBUILD_MODULES := 1
364 #ifeq ($(MAKECMDGOALS),)
365 # KBUILD_MODULES := 1
368 # Check ths size of a binary:
371 # #2: Size limit in bytes (decimal or 0xhex)
373 actual=$$( wc -c $1 | awk '{print $$1}'); \
374 limit=$$( printf "%d" $2 ); \
375 if test $$actual -gt $$limit; then \
376 echo "$1 exceeds file size limit:" >&2; \
377 echo " limit: $$(printf %#x $$limit) bytes" >&2; \
378 echo " actual: $$(printf %#x $$actual) bytes" >&2; \
379 echo " excess: $$(printf %#x $$((actual - limit))) bytes" >&2;\
385 export KBUILD_MODULES KBUILD_BUILTIN
386 export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD
388 # We need some generic definitions (do not try to remake the file).
389 scripts/Kbuild.include: ;
390 include scripts/Kbuild.include
392 # Make variables (CC, etc...)
394 AS = $(CROSS_COMPILE)as
396 ifneq ($(shell $(CROSS_COMPILE)ld.bfd -v 2> /dev/null),)
397 LD = $(CROSS_COMPILE)ld.bfd
399 LD = $(CROSS_COMPILE)ld
401 CC = $(CROSS_COMPILE)gcc
403 AR = $(CROSS_COMPILE)ar
404 NM = $(CROSS_COMPILE)nm
405 LDR = $(CROSS_COMPILE)ldr
406 STRIP = $(CROSS_COMPILE)strip
407 OBJCOPY = $(CROSS_COMPILE)objcopy
408 OBJDUMP = $(CROSS_COMPILE)objdump
417 # The devicetree compiler and pylibfdt are automatically built unless DTC is
418 # provided. If DTC is provided, it is assumed the pylibfdt is available too.
419 DTC_INTREE := $(objtree)/scripts/dtc/dtc
421 DTC_MIN_VERSION := 010406
425 CHECKFLAGS := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
426 -Wbitwise -Wno-return-void -D__CHECK_ENDIAN__ $(CF)
428 KBUILD_CPPFLAGS := -D__KERNEL__ -D__UBOOT__
430 KBUILD_CFLAGS := -Wall -Wstrict-prototypes \
431 -Wno-format-security \
432 -fno-builtin -ffreestanding $(CSTD_FLAG)
433 KBUILD_CFLAGS += -fshort-wchar -fno-strict-aliasing
434 KBUILD_AFLAGS := -D__ASSEMBLY__
437 ifeq ($(cc-name),clang)
438 ifneq ($(CROSS_COMPILE),)
439 CLANG_TARGET := --target=$(notdir $(CROSS_COMPILE:%-=%))
440 GCC_TOOLCHAIN_DIR := $(dir $(shell which $(LD)))
441 CLANG_PREFIX := --prefix=$(GCC_TOOLCHAIN_DIR)
442 GCC_TOOLCHAIN := $(realpath $(GCC_TOOLCHAIN_DIR)/..)
444 ifneq ($(GCC_TOOLCHAIN),)
445 CLANG_GCC_TC := --gcc-toolchain=$(GCC_TOOLCHAIN)
447 KBUILD_CFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
448 KBUILD_AFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
449 KBUILD_CFLAGS += $(call cc-option, -no-integrated-as)
450 KBUILD_AFLAGS += $(call cc-option, -no-integrated-as)
453 # Don't generate position independent code
454 KBUILD_CFLAGS += $(call cc-option,-fno-PIE)
455 KBUILD_AFLAGS += $(call cc-option,-fno-PIE)
457 # Read UBOOTRELEASE from include/config/uboot.release (if it exists)
458 UBOOTRELEASE = $(shell cat include/config/uboot.release 2> /dev/null)
459 UBOOTVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)
461 export VERSION PATCHLEVEL SUBLEVEL UBOOTRELEASE UBOOTVERSION
462 export ARCH CPU BOARD VENDOR SOC CPUDIR BOARDDIR
463 export CONFIG_SHELL HOSTCC KBUILD_HOSTCFLAGS CROSS_COMPILE AS LD CC
464 export CPP AR NM LDR STRIP OBJCOPY OBJDUMP KBUILD_HOSTLDFLAGS KBUILD_HOSTLDLIBS
465 export MAKE LEX YACC AWK PERL PYTHON PYTHON2 PYTHON3
466 export HOSTCXX KBUILD_HOSTCXXFLAGS CHECK CHECKFLAGS DTC DTC_FLAGS
468 export KBUILD_CPPFLAGS NOSTDINC_FLAGS UBOOTINCLUDE OBJCOPYFLAGS KBUILD_LDFLAGS
469 export KBUILD_CFLAGS KBUILD_AFLAGS
471 export CC_VERSION_TEXT := $(shell $(CC) --version | head -n 1)
473 # When compiling out-of-tree modules, put MODVERDIR in the module
474 # tree rather than in the kernel tree. The kernel tree might
476 export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions
478 # Files to ignore in find ... statements
480 export RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o \
481 -name CVS -o -name .pc -o -name .hg -o -name .git \) \
483 export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn \
484 --exclude CVS --exclude .pc --exclude .hg --exclude .git
486 # ===========================================================================
487 # Rules shared between *config targets and build targets
489 # Basic helpers built in scripts/
490 PHONY += scripts_basic
492 $(Q)$(MAKE) $(build)=scripts/basic
493 $(Q)rm -f .tmp_quiet_recordmcount
495 # To avoid any implicit rule to kick in, define an empty command.
496 scripts/basic/%: scripts_basic ;
498 PHONY += outputmakefile
499 # outputmakefile generates a Makefile in the output directory, if using a
500 # separate output directory. This allows convenient use of make in the
503 ifneq ($(KBUILD_SRC),)
504 $(Q)ln -fsn $(srctree) source
505 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/mkmakefile $(srctree)
508 # To make sure we do not include .config for any of the *config targets
509 # catch them early, and hand them over to scripts/kconfig/Makefile
510 # It is allowed to specify more targets when calling make, including
511 # mixing *config targets and build targets.
512 # For example 'make oldconfig all'.
513 # Detect when mixed targets is specified, and make a second invocation
514 # of make so .config is not included in this case either (for *config).
516 version_h := include/generated/version_autogenerated.h
517 timestamp_h := include/generated/timestamp_autogenerated.h
518 defaultenv_h := include/generated/defaultenv_autogenerated.h
519 dt_h := include/generated/dt.h
521 no-dot-config-targets := clean clobber mrproper distclean \
522 help %docs check% coccicheck \
523 ubootversion backup tests check qcheck tcheck
529 ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
530 ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
535 ifeq ($(KBUILD_EXTMOD),)
536 ifneq ($(filter config %config,$(MAKECMDGOALS)),)
538 ifneq ($(words $(MAKECMDGOALS)),1)
544 ifeq ($(mixed-targets),1)
545 # ===========================================================================
546 # We're called with mixed targets (*config and build targets).
547 # Handle them one by one.
549 PHONY += $(MAKECMDGOALS) __build_one_by_one
551 $(filter-out __build_one_by_one, $(MAKECMDGOALS)): __build_one_by_one
556 for i in $(MAKECMDGOALS); do \
557 $(MAKE) -f $(srctree)/Makefile $$i; \
561 ifeq ($(config-targets),1)
562 # ===========================================================================
563 # *config targets only - make sure prerequisites are updated, and descend
564 # in scripts/kconfig to make the *config target
566 KBUILD_DEFCONFIG := sandbox_defconfig
567 export KBUILD_DEFCONFIG KBUILD_KCONFIG
569 config: scripts_basic outputmakefile FORCE
570 $(Q)$(MAKE) $(build)=scripts/kconfig $@
572 %config: scripts_basic outputmakefile FORCE
573 $(Q)$(MAKE) $(build)=scripts/kconfig $@
576 # ===========================================================================
577 # Build targets only - this includes vmlinux, arch specific targets, clean
578 # targets and others. In general all targets except *config targets.
580 # Additional helpers built in scripts/
581 # Carefully list dependencies so we do not try to build scripts twice
584 scripts: scripts_basic scripts_dtc include/config/auto.conf
585 $(Q)$(MAKE) $(build)=$(@)
587 ifeq ($(dot-config),1)
589 -include include/config/auto.conf
591 # Read in dependencies to all Kconfig* files, make sure to run
592 # oldconfig if changes are detected.
593 -include include/config/auto.conf.cmd
595 # To avoid any implicit rule to kick in, define an empty command
596 $(KCONFIG_CONFIG) include/config/auto.conf.cmd: ;
598 # If .config is newer than include/config/auto.conf, someone tinkered
599 # with it and forgot to run make oldconfig.
600 # if auto.conf.cmd is missing then we are probably in a cleaned tree so
601 # we execute the config step to be sure to catch updated Kconfig files
602 include/config/%.conf: $(KCONFIG_CONFIG) include/config/auto.conf.cmd
603 $(Q)$(MAKE) -f $(srctree)/Makefile syncconfig
604 @# If the following part fails, include/config/auto.conf should be
605 @# deleted so "make silentoldconfig" will be re-run on the next build.
606 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf || \
607 { rm -f include/config/auto.conf; false; }
608 @# include/config.h has been updated after "make silentoldconfig".
609 @# We need to touch include/config/auto.conf so it gets newer
610 @# than include/config.h.
611 @# Otherwise, 'make silentoldconfig' would be invoked twice.
612 $(Q)touch include/config/auto.conf
614 u-boot.cfg spl/u-boot.cfg tpl/u-boot.cfg:
615 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf $(@)
617 -include include/autoconf.mk
618 -include include/autoconf.mk.dep
620 # We want to include arch/$(ARCH)/config.mk only when include/config/auto.conf
621 # is up-to-date. When we switch to a different board configuration, old CONFIG
622 # macros are still remaining in include/config/auto.conf. Without the following
623 # gimmick, wrong config.mk would be included leading nasty warnings/errors.
624 ifneq ($(wildcard $(KCONFIG_CONFIG)),)
625 ifneq ($(wildcard include/config/auto.conf),)
626 autoconf_is_old := $(shell find . -path ./$(KCONFIG_CONFIG) -newer \
627 include/config/auto.conf)
628 ifeq ($(autoconf_is_old),)
630 include arch/$(ARCH)/Makefile
635 # These are set by the arch-specific config.mk. Make sure they are exported
636 # so they can be used when building an EFI application.
637 export EFI_LDS # Filename of EFI link script in arch/$(ARCH)/lib
638 export EFI_CRT0 # Filename of EFI CRT0 in arch/$(ARCH)/lib
639 export EFI_RELOC # Filename of EFU relocation code in arch/$(ARCH)/lib
640 export CFLAGS_EFI # Compiler flags to add when building EFI app
641 export CFLAGS_NON_EFI # Compiler flags to remove when building EFI app
642 export EFI_TARGET # binutils target if EFI is natively supported
644 # If board code explicitly specified LDSCRIPT or CONFIG_SYS_LDSCRIPT, use
645 # that (or fail if absent). Otherwise, search for a linker script in a
649 #LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds.debug
650 ifdef CONFIG_SYS_LDSCRIPT
651 # need to strip off double quotes
652 LDSCRIPT := $(srctree)/$(CONFIG_SYS_LDSCRIPT:"%"=%)
656 # If there is no specified link script, we look in a number of places for it
658 ifeq ($(wildcard $(LDSCRIPT)),)
659 LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds
661 ifeq ($(wildcard $(LDSCRIPT)),)
662 LDSCRIPT := $(srctree)/$(CPUDIR)/u-boot.lds
664 ifeq ($(wildcard $(LDSCRIPT)),)
665 LDSCRIPT := $(srctree)/arch/$(ARCH)/cpu/u-boot.lds
670 # Dummy target needed, because used as prerequisite
671 include/config/auto.conf: ;
672 endif # $(dot-config)
675 # Xtensa linker script cannot be preprocessed with -ansi because of
676 # preprocessor operations on strings that don't make C identifiers.
678 ifeq ($(CONFIG_XTENSA),)
682 ifdef CONFIG_CC_OPTIMIZE_FOR_SIZE
690 export LTO_CFLAGS LTO_FINAL_LDFLAGS
692 ifeq ($(cc-name),clang)
694 LTO_FINAL_LDFLAGS += -flto
696 AR = $(shell $(CC) -print-prog-name=llvm-ar)
697 NM = $(shell $(CC) -print-prog-name=llvm-nm)
699 NPROC := $(shell nproc 2>/dev/null || echo 1)
700 LTO_CFLAGS += -flto=$(NPROC)
701 LTO_FINAL_LDFLAGS += -fuse-linker-plugin -flto=$(NPROC)
703 # use plugin aware tools
704 AR = $(CROSS_COMPILE)gcc-ar
705 NM = $(CROSS_COMPILE)gcc-nm
708 CFLAGS_NON_EFI += $(LTO_CFLAGS)
710 KBUILD_CFLAGS += $(LTO_CFLAGS)
713 ifeq ($(CONFIG_STACKPROTECTOR),y)
714 KBUILD_CFLAGS += $(call cc-option,-fstack-protector-strong)
715 CFLAGS_EFI += $(call cc-option,-fno-stack-protector)
717 KBUILD_CFLAGS += $(call cc-option,-fno-stack-protector)
719 KBUILD_CFLAGS += $(call cc-option,-fno-delete-null-pointer-checks)
721 # disable pointer signed / unsigned warnings in gcc 4.0
722 KBUILD_CFLAGS += -Wno-pointer-sign
724 # disable stringop warnings in gcc 8+
725 KBUILD_CFLAGS += $(call cc-disable-warning, stringop-truncation)
727 KBUILD_CFLAGS += $(call cc-disable-warning, zero-length-bounds)
728 KBUILD_CFLAGS += $(call cc-disable-warning, array-bounds)
729 KBUILD_CFLAGS += $(call cc-disable-warning, stringop-overflow)
731 # Enabled with W=2, disabled by default as noisy
732 KBUILD_CFLAGS += $(call cc-disable-warning, maybe-uninitialized)
734 # change __FILE__ to the relative path from the srctree
735 KBUILD_CFLAGS += $(call cc-option,-fmacro-prefix-map=$(srctree)/=)
738 # $(KBUILD_AFLAGS) sets -g, which causes gcc to pass a suitable -g<format>
739 # option to the assembler.
742 # Report stack usage if supported
743 # ARC tools based on GCC 7.1 has an issue with stack usage
744 # with naked functions, see commit message for more details
746 ifeq ($(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-stack-usage.sh $(CC)),y)
747 KBUILD_CFLAGS += -fstack-usage
751 KBUILD_CFLAGS += $(call cc-option,-Wno-format-nonliteral)
752 KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
754 ifdef CONFIG_CC_IS_CLANG
755 KBUILD_CPPFLAGS += $(call cc-option,-Qunused-arguments,)
756 KBUILD_CFLAGS += $(call cc-disable-warning, format-invalid-specifier)
757 KBUILD_CFLAGS += $(call cc-disable-warning, gnu)
758 KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
759 # Quiet clang warning: comparison of unsigned expression < 0 is always false
760 KBUILD_CFLAGS += $(call cc-disable-warning, tautological-compare)
761 # CLANG uses a _MergedGlobals as optimization, but this breaks modpost, as the
762 # source of a reference will be _MergedGlobals and not on of the whitelisted names.
763 # See modpost pattern 2
764 KBUILD_CFLAGS += $(call cc-option, -mno-global-merge,)
765 KBUILD_CFLAGS += $(call cc-option, -fcatch-undefined-behavior)
768 # These warnings generated too much noise in a regular build.
769 # Use make W=1 to enable them (see scripts/Makefile.extrawarn)
770 KBUILD_CFLAGS += $(call cc-disable-warning, unused-but-set-variable)
772 # Prohibit date/time macros, which would make the build non-deterministic
773 KBUILD_CFLAGS += $(call cc-option,-Werror=date-time)
775 include scripts/Makefile.extrawarn
777 # Add user supplied CPPFLAGS, AFLAGS and CFLAGS as the last assignments
778 KBUILD_CPPFLAGS += $(KCPPFLAGS)
779 KBUILD_AFLAGS += $(KAFLAGS)
780 KBUILD_CFLAGS += $(KCFLAGS)
782 KBUILD_HOSTCFLAGS += $(if $(CONFIG_TOOLS_DEBUG),-g)
784 # Use UBOOTINCLUDE when you must reference the include/ directory.
785 # Needed to be compatible with the O= option
788 $(if $(KBUILD_SRC), -I$(srctree)/include) \
789 $(if $(CONFIG_$(SPL_)SYS_THUMB_BUILD), \
790 $(if $(CONFIG_HAS_THUMB2), \
791 $(if $(CONFIG_CPU_V7M), \
792 -I$(srctree)/arch/arm/thumb1/include), \
793 -I$(srctree)/arch/arm/thumb1/include)) \
794 -I$(srctree)/arch/$(ARCH)/include \
795 -include $(srctree)/include/linux/kconfig.h
797 NOSTDINC_FLAGS += -nostdinc -isystem $(shell $(CC) -print-file-name=include)
800 cpp_flags := $(KBUILD_CPPFLAGS) $(PLATFORM_CPPFLAGS) $(UBOOTINCLUDE) \
802 c_flags := $(KBUILD_CFLAGS) $(cpp_flags)
804 #########################################################################
805 # U-Boot objects....order is important (i.e. start must be first)
807 HAVE_VENDOR_COMMON_LIB = $(if $(wildcard $(srctree)/board/$(VENDOR)/common/Makefile),y,n)
809 libs-$(CONFIG_API) += api/
810 libs-$(HAVE_VENDOR_COMMON_LIB) += board/$(VENDOR)/common/
814 libs-$(CONFIG_OF_EMBED) += dts/
821 libs-$(CONFIG_SYS_FSL_DDR) += drivers/ddr/fsl/
822 libs-$(CONFIG_SYS_FSL_MMDC) += drivers/ddr/fsl/
823 libs-$(CONFIG_$(SPL_)ALTERA_SDRAM) += drivers/ddr/altera/
824 libs-y += drivers/usb/cdns3/
825 libs-y += drivers/usb/dwc3/
826 libs-y += drivers/usb/common/
827 libs-y += drivers/usb/emul/
828 libs-y += drivers/usb/eth/
829 libs-$(CONFIG_USB_DEVICE) += drivers/usb/gadget/
830 libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/
831 libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/udc/
832 libs-y += drivers/usb/host/
833 libs-y += drivers/usb/mtu3/
834 libs-y += drivers/usb/musb/
835 libs-y += drivers/usb/musb-new/
836 libs-y += drivers/usb/phy/
837 libs-y += drivers/usb/ulpi/
841 libs-$(CONFIG_UNIT_TEST) += test/
842 libs-$(CONFIG_UT_ENV) += test/env/
843 libs-$(CONFIG_UT_OPTEE) += test/optee/
844 libs-$(CONFIG_UT_OVERLAY) += test/overlay/
846 libs-y += $(if $(BOARDDIR),board/$(BOARDDIR)/)
848 libs-y := $(sort $(libs-y))
850 u-boot-dirs := $(patsubst %/,%,$(filter %/, $(libs-y))) tools examples
852 u-boot-alldirs := $(sort $(u-boot-dirs) $(patsubst %/,%,$(filter %/, $(libs-))))
854 libs-y := $(patsubst %/, %/built-in.o, $(libs-y))
856 u-boot-init := $(head-y)
857 u-boot-main := $(libs-y)
861 ifeq ($(CONFIG_USE_PRIVATE_LIBGCC),y)
862 PLATFORM_LIBGCC = arch/$(ARCH)/lib/lib.a
864 PLATFORM_LIBGCC := -L $(shell dirname `$(CC) $(c_flags) -print-libgcc-file-name`) -lgcc
866 PLATFORM_LIBS += $(PLATFORM_LIBGCC)
868 ifdef CONFIG_CC_COVERAGE
869 KBUILD_CFLAGS += --coverage
870 PLATFORM_LIBGCC += -lgcov
874 export PLATFORM_LIBGCC
876 # Special flags for CPP when processing the linker script.
877 # Pass the version down so we can handle backwards compatibility
880 -include $(srctree)/include/u-boot/u-boot.lds.h \
882 $(shell $(LD) --version | \
883 sed -ne 's/GNU ld version \([0-9][0-9]*\)\.\([0-9][0-9]*\).*/-DLD_MAJOR=\1 -DLD_MINOR=\2/p')
885 #########################################################################
886 #########################################################################
888 ifneq ($(CONFIG_BOARD_SIZE_LIMIT),)
889 BOARD_SIZE_CHECK= @ $(call size_check,$@,$(CONFIG_BOARD_SIZE_LIMIT))
894 ifneq ($(CONFIG_SPL_SIZE_LIMIT),0x0)
895 SPL_SIZE_CHECK = @$(call size_check,$@,$$(tools/spl_size_limit))
900 ifneq ($(CONFIG_TPL_SIZE_LIMIT),0x0)
901 TPL_SIZE_CHECK = @$(call size_check,$@,$(CONFIG_TPL_SIZE_LIMIT))
906 # Statically apply RELA-style relocations (currently arm64 only)
907 # This is useful for arm64 where static relocation needs to be performed on
908 # the raw binary, but certain simulators only accept an ELF file (but don't
909 # do the relocation).
910 ifneq ($(CONFIG_STATIC_RELA),)
911 # $(1) is u-boot ELF, $(2) is u-boot bin, $(3) is text base
912 quiet_cmd_static_rela = RELOC $@
914 start=$$($(NM) $(2) | grep __rel_dyn_start | cut -f 1 -d ' '); \
915 end=$$($(NM) $(2) | grep __rel_dyn_end | cut -f 1 -d ' '); \
916 tools/relocate-rela $(3) $(4) $$start $$end
918 quiet_cmd_static_rela =
922 # Always append INPUTS so that arch config.mk's can add custom ones
923 INPUTS-y += u-boot.srec u-boot.bin u-boot.sym System.map binary_size_check
925 INPUTS-$(CONFIG_ONENAND_U_BOOT) += u-boot-onenand.bin
926 ifeq ($(CONFIG_SPL_FSL_PBL),y)
927 INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot-with-spl-pbl.bin
929 ifneq ($(CONFIG_NXP_ESBC), y)
930 # For Secure Boot The Image needs to be signed and Header must also
931 # be included. So The image has to be built explicitly
932 INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot.pbl
935 INPUTS-$(CONFIG_SPL) += spl/u-boot-spl.bin
936 ifeq ($(CONFIG_MX6)$(CONFIG_IMX_HAB), yy)
937 INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
939 ifeq ($(CONFIG_MX7)$(CONFIG_IMX_HAB), yy)
940 INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
942 INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot.img
945 INPUTS-$(CONFIG_TPL) += tpl/u-boot-tpl.bin
946 INPUTS-$(CONFIG_OF_SEPARATE) += u-boot.dtb
947 INPUTS-$(CONFIG_BINMAN_STANDALONE_FDT) += u-boot.dtb
948 ifeq ($(CONFIG_SPL_FRAMEWORK),y)
949 INPUTS-$(CONFIG_OF_SEPARATE) += u-boot-dtb.img
951 INPUTS-$(CONFIG_SANDBOX) += u-boot.dtb
952 ifneq ($(CONFIG_SPL_TARGET),)
953 INPUTS-$(CONFIG_SPL) += $(CONFIG_SPL_TARGET:"%"=%)
955 INPUTS-$(CONFIG_REMAKE_ELF) += u-boot.elf
956 INPUTS-$(CONFIG_EFI_APP) += u-boot-app.efi
957 INPUTS-$(CONFIG_EFI_STUB) += u-boot-payload.efi
959 # Generate this input file for binman
960 ifeq ($(CONFIG_SPL),)
961 INPUTS-$(CONFIG_ARCH_MEDIATEK) += u-boot-mtk.bin
964 # Add optional build target if defined in board/cpu/soc headers
965 ifneq ($(CONFIG_BUILD_TARGET),)
966 INPUTS-y += $(CONFIG_BUILD_TARGET:"%"=%)
969 ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
970 INPUTS-y += init_sp_bss_offset_check
973 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
974 INPUTS-y += u-boot-with-dtb.bin
977 ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
978 # On ARM64 this target is produced by binman so we don't need this dep
979 ifeq ($(CONFIG_ARM64),y)
980 ifeq ($(CONFIG_SPL),y)
981 # TODO: Get binman to generate this too
982 INPUTS-y += u-boot-rockchip.bin
985 ifeq ($(CONFIG_SPL),y)
986 # Generate these inputs for binman which will create the output files
987 INPUTS-y += idbloader.img u-boot.img
992 INPUTS-$(CONFIG_X86) += u-boot-x86-start16.bin u-boot-x86-reset16.bin \
993 $(if $(CONFIG_SPL_X86_16BIT_INIT),spl/u-boot-spl.bin) \
994 $(if $(CONFIG_TPL_X86_16BIT_INIT),tpl/u-boot-tpl.bin)
996 LDFLAGS_u-boot += $(LDFLAGS_FINAL)
998 # Avoid 'Not enough room for program headers' error on binutils 2.28 onwards.
999 LDFLAGS_u-boot += $(call ld-option, --no-dynamic-linker)
1002 LDFLAGS_u-boot += -z notext
1004 LDFLAGS_u-boot += --build-id=none
1006 ifeq ($(CONFIG_ARC)$(CONFIG_NIOS2)$(CONFIG_X86)$(CONFIG_XTENSA),)
1007 LDFLAGS_u-boot += -Ttext $(CONFIG_SYS_TEXT_BASE)
1010 # insure the checker run with the right endianness
1011 CHECKFLAGS += $(if $(CONFIG_CPU_BIG_ENDIAN),-mbig-endian,-mlittle-endian)
1013 # the checker needs the correct machine size
1014 CHECKFLAGS += $(if $(CONFIG_64BIT),-m64,-m32)
1016 # Normally we fill empty space with 0xff
1017 quiet_cmd_objcopy = OBJCOPY $@
1018 cmd_objcopy = $(OBJCOPY) --gap-fill=0xff $(OBJCOPYFLAGS) \
1019 $(OBJCOPYFLAGS_$(@F)) $< $@
1021 # Provide a version which does not do this, for use by EFI
1022 quiet_cmd_zobjcopy = OBJCOPY $@
1023 cmd_zobjcopy = $(OBJCOPY) $(OBJCOPYFLAGS) $(OBJCOPYFLAGS_$(@F)) $< $@
1025 quiet_cmd_efipayload = OBJCOPY $@
1026 cmd_efipayload = $(OBJCOPY) -I binary -O $(EFIPAYLOAD_BFDTARGET) -B $(EFIPAYLOAD_BFDARCH) $< $@
1028 MKIMAGEOUTPUT ?= /dev/null
1030 quiet_cmd_mkimage = MKIMAGE $@
1031 cmd_mkimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) -d $< $@ \
1032 >$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1034 quiet_cmd_mkfitimage = MKIMAGE $@
1035 cmd_mkfitimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) \
1036 -f $(U_BOOT_ITS) -p $(CONFIG_FIT_EXTERNAL_OFFSET) $@ \
1037 >$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1039 quiet_cmd_cat = CAT $@
1040 cmd_cat = cat $(filter-out $(PHONY), $^) > $@
1042 append = cat $(filter-out $< $(PHONY), $^) >> $@
1044 quiet_cmd_pad_cat = CAT $@
1045 cmd_pad_cat = $(cmd_objcopy) && $(append) || { rm -f $@; false; }
1047 quiet_cmd_lzma = LZMA $@
1048 cmd_lzma = lzma -c -z -k -9 $< > $@
1052 quiet_cmd_cfgcheck = CFGCHK $2
1053 cmd_cfgcheck = $(srctree)/scripts/check-config.sh $2 \
1054 $(srctree)/scripts/config_whitelist.txt $(srctree)
1056 # Concat the value of all the CONFIGs (result is 'y' or 'yy', etc. )
1057 got = $(foreach cfg,$(1),$($(cfg)))
1059 # expected value 'y for each one
1060 expect = $(foreach cfg,$(1),y)
1062 # Show a deprecation message
1064 # 1: List of CONFIG_DM_... to migrate to (e.g. "CONFIG_DM_MMC CONFIG_BLK")
1065 # 2: Name of component (e.g . "Ethernet drivers")
1066 # 3: Release deadline (e.g. "v202.07")
1067 # 4: Condition to require before checking (e.g. "$(CONFIG_NET)")
1068 # Note: Script avoids bash construct, hence the strange double 'if'
1069 # (patches welcome!)
1071 @if [ -n "$(strip $(4))" ]; then if [ "$(got)" != "$(expect)" ]; then \
1072 echo >&2 "===================== WARNING ======================"; \
1073 echo >&2 "This board does not use $(firstword $(1)) (Driver Model"; \
1074 echo >&2 "for $(2)). Please update the board to use"; \
1075 echo >&2 "$(firstword $(1)) before the $(3) release. Failure to"; \
1076 echo >&2 "update by the deadline may result in board removal."; \
1077 echo >&2 "See doc/driver-model/migration.rst for more info."; \
1078 echo >&2 "===================================================="; \
1086 all: .binman_stamp inputs
1087 ifeq ($(CONFIG_BINMAN),y)
1088 $(call if_changed,binman)
1091 # Timestamp file to make sure that binman always runs
1092 .binman_stamp: FORCE
1095 ifeq ($(CONFIG_DEPRECATED),y)
1096 $(warning "You have deprecated configuration options enabled in your .config! Please check your configuration.")
1098 ifeq ($(CONFIG_OF_EMBED)$(CONFIG_EFI_APP),y)
1099 @echo >&2 "===================== WARNING ======================"
1100 @echo >&2 "CONFIG_OF_EMBED is enabled. This option should only"
1101 @echo >&2 "be used for debugging purposes. Please use"
1102 @echo >&2 "CONFIG_OF_SEPARATE for boards in mainline."
1103 @echo >&2 "See doc/README.fdt-control for more info."
1104 @echo >&2 "===================================================="
1106 ifneq ($(CONFIG_SPL_FIT_GENERATOR),)
1107 @echo >&2 "===================== WARNING ======================"
1108 @echo >&2 "This board uses CONFIG_SPL_FIT_GENERATOR. Please migrate"
1109 @echo >&2 "to binman instead, to avoid the proliferation of"
1110 @echo >&2 "arch-specific scripts with no tests."
1111 @echo >&2 "===================================================="
1113 ifneq ($(CONFIG_DM),y)
1114 @echo >&2 "===================== WARNING ======================"
1115 @echo >&2 "This board does not use CONFIG_DM. CONFIG_DM will be"
1116 @echo >&2 "compulsory starting with the v2020.01 release."
1117 @echo >&2 "Failure to update may result in board removal."
1118 @echo >&2 "See doc/driver-model/migration.rst for more info."
1119 @echo >&2 "===================================================="
1121 $(call deprecated,CONFIG_WDT,DM watchdog,v2019.10,\
1122 $(CONFIG_WATCHDOG)$(CONFIG_HW_WATCHDOG))
1123 $(call deprecated,CONFIG_DM_ETH,Ethernet drivers,v2020.07,$(CONFIG_NET))
1124 $(call deprecated,CONFIG_DM_I2C,I2C drivers,v2022.04,$(CONFIG_SYS_I2C_LEGACY))
1125 @# Check that this build does not use CONFIG options that we do not
1126 @# know about unless they are in Kconfig. All the existing CONFIG
1127 @# options are whitelisted, so new ones should not be added.
1128 $(call cmd,cfgcheck,u-boot.cfg)
1134 $(Q)$(MAKE) $(build)=dts dtbs
1136 quiet_cmd_copy = COPY $@
1139 ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1141 ifeq ($(CONFIG_MULTI_DTB_FIT_LZO),y)
1142 FINAL_DTB_CONTAINER = fit-dtb.blob.lzo
1143 else ifeq ($(CONFIG_MULTI_DTB_FIT_GZIP),y)
1144 FINAL_DTB_CONTAINER = fit-dtb.blob.gz
1146 FINAL_DTB_CONTAINER = fit-dtb.blob
1149 fit-dtb.blob.gz: fit-dtb.blob
1152 fit-dtb.blob.lzo: fit-dtb.blob
1155 fit-dtb.blob: dts/dt.dtb FORCE
1156 $(call if_changed,mkimage)
1157 ifneq ($(SOURCE_DATE_EPOCH),)
1158 touch -d @$(SOURCE_DATE_EPOCH) fit-dtb.blob
1159 chmod 0600 fit-dtb.blob
1162 MKIMAGEFLAGS_fit-dtb.blob = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
1164 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) -d /dev/null
1166 MKIMAGEFLAGS_fit-dtb.blob += -B 0x8
1169 u-boot-fit-dtb.bin: u-boot-nodtb.bin $(EXT_DTB)
1170 $(call if_changed,cat)
1172 u-boot-fit-dtb.bin: u-boot-nodtb.bin $(FINAL_DTB_CONTAINER)
1173 $(call if_changed,cat)
1176 u-boot.bin: u-boot-fit-dtb.bin FORCE
1177 $(call if_changed,copy)
1179 u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1180 $(call if_changed,cat)
1182 else ifeq ($(CONFIG_OF_SEPARATE),y)
1183 u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1184 $(call if_changed,cat)
1186 u-boot.bin: u-boot-dtb.bin FORCE
1187 $(call if_changed,copy)
1189 u-boot.bin: u-boot-nodtb.bin FORCE
1190 $(call if_changed,copy)
1193 # we call Makefile in arch/arm/mach-imx which
1194 # has targets which are dependent on targets defined
1195 # here. make could not resolve them and we must ensure
1196 # that they are finished before calling imx targets
1197 ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1198 IMX_DEPS = u-boot-fit-dtb.bin
1201 %.imx: $(IMX_DEPS) %.bin
1202 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1206 $(Q)$(MAKE) $(build)=arch/arm/cpu/armv7/vf610 $@
1208 quiet_cmd_copy = COPY $@
1211 u-boot.dtb: dts/dt.dtb
1214 OBJCOPYFLAGS_u-boot.hex := -O ihex
1216 OBJCOPYFLAGS_u-boot.srec := -O srec
1218 u-boot.hex u-boot.srec: u-boot FORCE
1219 $(call if_changed,objcopy)
1221 OBJCOPYFLAGS_u-boot-elf.srec := $(OBJCOPYFLAGS_u-boot.srec)
1223 u-boot-elf.srec: u-boot.elf FORCE
1224 $(call if_changed,objcopy)
1226 OBJCOPYFLAGS_u-boot-spl.srec = $(OBJCOPYFLAGS_u-boot.srec)
1228 spl/u-boot-spl.srec: spl/u-boot-spl FORCE
1229 $(call if_changed,objcopy)
1232 $(Q)$(MAKE) $(build)=arch/arm/mach-rmobile $@
1234 OBJCOPYFLAGS_u-boot-nodtb.bin := -O binary \
1235 $(if $(CONFIG_X86_16BIT_INIT),-R .start16 -R .resetvec) \
1236 $(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR),-R .bootpg -R .resetvec)
1238 binary_size_check: u-boot-nodtb.bin FORCE
1239 @file_size=$(shell wc -c u-boot-nodtb.bin | awk '{print $$1}') ; \
1240 map_size=$(shell cat u-boot.map | \
1241 awk '/_image_copy_start/ {start = $$1} /_image_binary_end/ {end = $$1} END {if (start != "" && end != "") print "ibase=16; " toupper(end) " - " toupper(start)}' \
1244 if [ "" != "$$map_size" ]; then \
1245 if test $$map_size -ne $$file_size; then \
1246 echo "u-boot.map shows a binary size of $$map_size" >&2 ; \
1247 echo " but u-boot-nodtb.bin shows $$file_size" >&2 ; \
1252 ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
1253 ifneq ($(CONFIG_SYS_MALLOC_F_LEN),)
1254 subtract_sys_malloc_f_len = space=$$(($${space} - $(CONFIG_SYS_MALLOC_F_LEN)))
1256 subtract_sys_malloc_f_len = true
1258 # The 1/4 margin below is somewhat arbitrary. The likely initial SP usage is
1259 # so low that the DTB could probably use 90%+ of the available space, for
1260 # current values of CONFIG_SYS_INIT_SP_BSS_OFFSET at least. However, let's be
1261 # safe for now and tweak this later if space becomes tight.
1262 # A rejected alternative would be to check that some absolute minimum stack
1263 # space was available. However, since CONFIG_SYS_INIT_SP_BSS_OFFSET is
1264 # deliberately build-specific, to take account of build-to-build stack usage
1265 # differences due to different feature sets, there is no common absolute value
1267 init_sp_bss_offset_check: u-boot.dtb FORCE
1268 @dtb_size=$(shell wc -c u-boot.dtb | awk '{print $$1}') ; \
1269 space=$(CONFIG_SYS_INIT_SP_BSS_OFFSET) ; \
1270 $(subtract_sys_malloc_f_len) ; \
1271 quarter_space=$$(($${space} / 4)) ; \
1272 if [ $${dtb_size} -gt $${quarter_space} ]; then \
1273 echo "u-boot.dtb is larger than 1 quarter of " >&2 ; \
1274 echo "(CONFIG_SYS_INIT_SP_BSS_OFFSET - CONFIG_SYS_MALLOC_F_LEN)" >&2 ; \
1279 shell_cmd = { $(call echo-cmd,$(1)) $(cmd_$(1)); }
1281 quiet_cmd_objcopy_uboot = OBJCOPY $@
1282 ifdef cmd_static_rela
1283 cmd_objcopy_uboot = $(cmd_objcopy) && $(call shell_cmd,static_rela,$<,$@,$(CONFIG_SYS_TEXT_BASE)) || { rm -f $@; false; }
1285 cmd_objcopy_uboot = $(cmd_objcopy)
1288 u-boot-nodtb.bin: u-boot FORCE
1289 $(call if_changed,objcopy_uboot)
1294 $(LDR) -T $(CONFIG_CPU) -c $@ $< $(LDR_FLAGS)
1298 # ---------------------------------------------------------------------------
1299 # Use 'make BINMAN_DEBUG=1' to enable debugging
1300 # Use 'make BINMAN_VERBOSE=3' to set vebosity level
1301 default_dt := $(if $(DEVICE_TREE),$(DEVICE_TREE),$(CONFIG_DEFAULT_DEVICE_TREE))
1303 quiet_cmd_binman = BINMAN $@
1304 cmd_binman = $(srctree)/tools/binman/binman $(if $(BINMAN_DEBUG),-D) \
1305 --toolpath $(objtree)/tools \
1306 $(if $(BINMAN_VERBOSE),-v$(BINMAN_VERBOSE)) \
1307 build -u -d u-boot.dtb -O . -m --allow-missing \
1308 -I . -I $(srctree) -I $(srctree)/board/$(BOARDDIR) \
1309 -I arch/$(ARCH)/dts -a of-list=$(CONFIG_OF_LIST) \
1310 -a atf-bl31-path=${BL31} \
1311 -a opensbi-path=${OPENSBI} \
1312 -a default-dt=$(default_dt) \
1313 -a scp-path=$(SCP) \
1314 -a spl-bss-pad=$(if $(CONFIG_SPL_SEPARATE_BSS),,1) \
1315 -a tpl-bss-pad=$(if $(CONFIG_TPL_SEPARATE_BSS),,1) \
1316 -a spl-dtb=$(CONFIG_SPL_OF_REAL) \
1317 -a tpl-dtb=$(CONFIG_TPL_OF_REAL) \
1320 OBJCOPYFLAGS_u-boot.ldr.hex := -I binary -O ihex
1322 OBJCOPYFLAGS_u-boot.ldr.srec := -I binary -O srec
1324 u-boot.ldr.hex u-boot.ldr.srec: u-boot.ldr FORCE
1325 $(call if_changed,objcopy)
1328 # U-Boot entry point, needed for booting of full-blown U-Boot
1329 # from the SPL U-Boot version.
1331 ifndef CONFIG_SYS_UBOOT_START
1332 CONFIG_SYS_UBOOT_START := $(CONFIG_SYS_TEXT_BASE)
1335 # Boards with more complex image requirements can provide an .its source file
1336 # or a generator script
1337 # NOTE: Please do not use this. We are migrating away from Makefile rules to use
1339 ifneq ($(CONFIG_SPL_FIT_SOURCE),"")
1340 U_BOOT_ITS := u-boot.its
1341 $(U_BOOT_ITS): $(subst ",,$(CONFIG_SPL_FIT_SOURCE))
1342 $(call if_changed,copy)
1344 ifneq ($(CONFIG_USE_SPL_FIT_GENERATOR),)
1345 U_BOOT_ITS := u-boot.its
1346 ifeq ($(CONFIG_SPL_FIT_GENERATOR),"arch/arm/mach-rockchip/make_fit_atf.py")
1347 U_BOOT_ITS_DEPS += u-boot
1349 $(U_BOOT_ITS): $(U_BOOT_ITS_DEPS) FORCE
1350 $(srctree)/$(CONFIG_SPL_FIT_GENERATOR) \
1351 $(patsubst %,arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) > $@
1355 ifdef CONFIG_SPL_LOAD_FIT
1356 MKIMAGEFLAGS_u-boot.img = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
1357 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1358 -p $(CONFIG_FIT_EXTERNAL_OFFSET) \
1359 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board" -E \
1360 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(DEVICE_TREE))) \
1361 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) \
1362 $(patsubst %,-b arch/$(ARCH)/dts/%.dtbo,$(subst ",,$(CONFIG_OF_OVERLAY_LIST)))
1364 MKIMAGEFLAGS_u-boot.img = -A $(ARCH) -T firmware -C none -O u-boot \
1365 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1366 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1367 MKIMAGEFLAGS_u-boot-ivt.img = -A $(ARCH) -T firmware_ivt -C none -O u-boot \
1368 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1369 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1370 u-boot-ivt.img: MKIMAGEOUTPUT = u-boot-ivt.img.log
1373 MKIMAGEFLAGS_u-boot-dtb.img = $(MKIMAGEFLAGS_u-boot.img)
1375 # Some boards have the kwbimage.cfg file written in advance, while some
1376 # other boards generate it on the fly during the build in the build tree.
1377 # Let's check if the file exists in the build tree first, otherwise we
1378 # fall back to use the one in the source tree.
1379 KWD_CONFIG_FILE = $(shell \
1380 if [ -f $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%) ]; then \
1381 echo -n $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
1383 echo -n $(srctree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
1386 MKIMAGEFLAGS_u-boot.kwb = -n $(KWD_CONFIG_FILE) \
1387 -T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE)
1389 MKIMAGEFLAGS_u-boot-spl.kwb = -n $(KWD_CONFIG_FILE) \
1390 -T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
1391 $(if $(KEYDIR),-k $(KEYDIR))
1393 MKIMAGEFLAGS_u-boot.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1394 -R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -T pblimage
1396 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1397 UBOOT_BIN := u-boot-with-dtb.bin
1399 UBOOT_BIN := u-boot.bin
1402 MKIMAGEFLAGS_u-boot-lzma.img = -A $(ARCH) -T standalone -C lzma -O u-boot \
1403 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1404 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1406 u-boot.bin.lzma: u-boot.bin FORCE
1407 $(call if_changed,lzma)
1409 u-boot-lzma.img: u-boot.bin.lzma FORCE
1410 $(call if_changed,mkimage)
1412 u-boot-dtb.img u-boot.img u-boot.kwb u-boot.pbl u-boot-ivt.img: \
1413 $(if $(CONFIG_SPL_LOAD_FIT),u-boot-nodtb.bin \
1414 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SANDBOX)$(CONFIG_BINMAN_STANDALONE_FDT),dts/dt.dtb) \
1415 ,$(UBOOT_BIN)) FORCE
1416 $(call if_changed,mkimage)
1419 ifeq ($(CONFIG_SPL_LOAD_FIT_FULL),y)
1420 MKIMAGEFLAGS_u-boot.itb =
1422 MKIMAGEFLAGS_u-boot.itb = -E
1424 MKIMAGEFLAGS_u-boot.itb += -B 0x8
1427 u-boot.itb: u-boot-nodtb.bin \
1428 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SANDBOX),dts/dt.dtb) \
1430 $(call if_changed,mkfitimage)
1434 u-boot-spl.kwb: u-boot.bin spl/u-boot-spl.bin FORCE
1435 $(call if_changed,mkimage)
1437 u-boot.sha1: u-boot.bin
1438 tools/ubsha1 u-boot.bin
1441 $(OBJDUMP) -d $< > $@
1443 ifneq ($(CONFIG_SPL_PAYLOAD),)
1444 SPL_PAYLOAD := $(CONFIG_SPL_PAYLOAD:"%"=%)
1446 SPL_PAYLOAD := u-boot.bin
1449 SPL_IMAGE := $(CONFIG_SPL_IMAGE:"%"=%)
1451 OBJCOPYFLAGS_u-boot-with-spl.bin = -I binary -O binary \
1452 --pad-to=$(CONFIG_SPL_PAD_TO)
1453 u-boot-with-spl.bin: $(SPL_IMAGE) $(SPL_PAYLOAD) FORCE
1454 $(call if_changed,pad_cat)
1456 ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
1459 ifeq ($(CONFIG_SPL)$(CONFIG_TPL),yy)
1460 MKIMAGEFLAGS_u-boot-tpl-rockchip.bin = -n $(CONFIG_SYS_SOC) -T rksd
1461 tpl/u-boot-tpl-rockchip.bin: tpl/u-boot-tpl.bin FORCE
1462 $(call if_changed,mkimage)
1463 idbloader.img: tpl/u-boot-tpl-rockchip.bin spl/u-boot-spl.bin FORCE
1464 $(call if_changed,cat)
1466 MKIMAGEFLAGS_idbloader.img = -n $(CONFIG_SYS_SOC) -T rksd
1467 idbloader.img: spl/u-boot-spl.bin FORCE
1468 $(call if_changed,mkimage)
1471 ifeq ($(CONFIG_ARM64),y)
1472 OBJCOPYFLAGS_u-boot-rockchip.bin = -I binary -O binary \
1473 --pad-to=$(CONFIG_SPL_PAD_TO) --gap-fill=0xff
1474 u-boot-rockchip.bin: idbloader.img u-boot.itb FORCE
1475 $(call if_changed,pad_cat)
1476 endif # CONFIG_ARM64
1478 endif # CONFIG_ARCH_ROCKCHIP
1480 ifeq ($(CONFIG_ARCH_LPC32XX)$(CONFIG_SPL),yy)
1481 MKIMAGEFLAGS_lpc32xx-spl.img = -T lpc32xximage -a $(CONFIG_SPL_TEXT_BASE)
1483 lpc32xx-spl.img: spl/u-boot-spl.bin FORCE
1484 $(call if_changed,mkimage)
1486 OBJCOPYFLAGS_lpc32xx-boot-0.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1488 lpc32xx-boot-0.bin: lpc32xx-spl.img FORCE
1489 $(call if_changed,objcopy)
1491 OBJCOPYFLAGS_lpc32xx-boot-1.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1493 lpc32xx-boot-1.bin: lpc32xx-spl.img FORCE
1494 $(call if_changed,objcopy)
1496 lpc32xx-full.bin: lpc32xx-boot-0.bin lpc32xx-boot-1.bin u-boot.img FORCE
1497 $(call if_changed,cat)
1501 OBJCOPYFLAGS_u-boot-with-tpl.bin = -I binary -O binary \
1502 --pad-to=$(CONFIG_TPL_PAD_TO)
1503 tpl/u-boot-with-tpl.bin: tpl/u-boot-tpl.bin u-boot.bin FORCE
1504 $(call if_changed,pad_cat)
1506 SPL: spl/u-boot-spl.bin FORCE
1507 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1509 ifeq ($(CONFIG_ARCH_IMX8M)$(CONFIG_ARCH_IMX8), y)
1510 ifeq ($(CONFIG_SPL_LOAD_IMX_CONTAINER), y)
1511 u-boot.cnt: u-boot.bin FORCE
1512 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1514 flash.bin: spl/u-boot-spl.bin u-boot.cnt FORCE
1515 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1517 ifeq ($(CONFIG_BINMAN),y)
1518 flash.bin: spl/u-boot-spl.bin $(INPUTS-y) FORCE
1519 $(call if_changed,binman)
1520 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1522 flash.bin: spl/u-boot-spl.bin u-boot.itb FORCE
1523 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1528 u-boot.uim: u-boot.bin FORCE
1529 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1531 u-boot-with-spl.imx u-boot-with-nand-spl.imx: SPL $(if $(CONFIG_OF_SEPARATE),u-boot.img,u-boot.uim) FORCE
1532 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1534 MKIMAGEFLAGS_u-boot.ubl = -n $(UBL_CONFIG) -T ublimage -e $(CONFIG_SYS_TEXT_BASE)
1536 u-boot.ubl: u-boot-with-spl.bin FORCE
1537 $(call if_changed,mkimage)
1539 MKIMAGEFLAGS_u-boot-spl.ais = -s -n $(if $(CONFIG_AIS_CONFIG_FILE), \
1540 $(srctree)/$(CONFIG_AIS_CONFIG_FILE:"%"=%),"/dev/null") \
1541 -T aisimage -e $(CONFIG_SPL_TEXT_BASE)
1542 spl/u-boot-spl.ais: spl/u-boot-spl.bin FORCE
1543 $(call if_changed,mkimage)
1545 OBJCOPYFLAGS_u-boot.ais = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1546 u-boot.ais: spl/u-boot-spl.ais u-boot.img FORCE
1547 $(call if_changed,pad_cat)
1549 u-boot-signed.sb: u-boot.bin spl/u-boot-spl.bin
1550 $(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot-signed.sb
1551 u-boot.sb: u-boot.bin spl/u-boot-spl.bin
1552 $(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot.sb
1554 MKIMAGEFLAGS_u-boot-spl.img = -A $(ARCH) -T firmware -C none \
1555 -a $(CONFIG_SPL_TEXT_BASE) -e $(CONFIG_SPL_TEXT_BASE) -n XLOADER
1556 spl/u-boot-spl.img: spl/u-boot-spl.bin FORCE
1557 $(call if_changed,mkimage)
1559 ifneq ($(CONFIG_ARCH_SOCFPGA),)
1560 quiet_cmd_gensplx4 = GENSPLX4 $@
1561 cmd_gensplx4 = $(OBJCOPY) -I binary -O binary --gap-fill=0x0 \
1562 --pad-to=$(CONFIG_SPL_PAD_TO) \
1563 spl/u-boot-spl.sfp spl/u-boot-spl.sfp && \
1564 cat spl/u-boot-spl.sfp spl/u-boot-spl.sfp \
1565 spl/u-boot-spl.sfp spl/u-boot-spl.sfp > $@ || { rm -f $@; false; }
1566 spl/u-boot-splx4.sfp: spl/u-boot-spl.sfp FORCE
1567 $(call if_changed,gensplx4)
1569 quiet_cmd_socboot = SOCBOOT $@
1570 cmd_socboot = cat spl/u-boot-splx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1571 u-boot-with-spl.sfp: spl/u-boot-splx4.sfp u-boot.img FORCE
1572 $(call if_changed,socboot)
1574 quiet_cmd_gensplpadx4 = GENSPLPADX4 $@
1575 cmd_gensplpadx4 = dd if=/dev/zero of=spl/u-boot-spl.pad bs=64 count=1024 ; \
1576 cat spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1577 spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1578 spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1579 spl/u-boot-spl.sfp spl/u-boot-spl.pad > $@ || \
1580 { rm -f $@ spl/u-boot-spl.pad; false; }
1581 u-boot-spl-padx4.sfp: spl/u-boot-spl.sfp FORCE
1582 $(call if_changed,gensplpadx4)
1584 quiet_cmd_socnandboot = SOCNANDBOOT $@
1585 cmd_socnandboot = cat u-boot-spl-padx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1586 u-boot-with-nand-spl.sfp: u-boot-spl-padx4.sfp u-boot.img FORCE
1587 $(call if_changed,socnandboot)
1591 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1592 u-boot-with-dtb.bin: u-boot.bin u-boot.dtb \
1593 $(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR), u-boot-br.bin) FORCE
1594 $(call if_changed,binman)
1596 ifeq ($(CONFIG_MPC85XX_HAVE_RESET_VECTOR),y)
1597 OBJCOPYFLAGS_u-boot-br.bin := -O binary -j .bootpg -j .resetvec
1598 u-boot-br.bin: u-boot FORCE
1599 $(call if_changed,objcopy)
1603 quiet_cmd_ldr = LD $@
1604 cmd_ldr = $(LD) $(LDFLAGS_$(@F)) \
1605 $(filter-out FORCE,$^) -o $@
1608 OBJCOPYFLAGS_u-boot-x86-start16.bin := -O binary -j .start16
1609 u-boot-x86-start16.bin: u-boot FORCE
1610 $(call if_changed,objcopy)
1612 OBJCOPYFLAGS_u-boot-x86-reset16.bin := -O binary -j .resetvec
1613 u-boot-x86-reset16.bin: u-boot FORCE
1614 $(call if_changed,objcopy)
1618 OBJCOPYFLAGS_u-boot-app.efi := $(OBJCOPYFLAGS_EFI)
1619 u-boot-app.efi: u-boot FORCE
1620 $(call if_changed,zobjcopy)
1622 u-boot.bin.o: u-boot.bin FORCE
1623 $(call if_changed,efipayload)
1625 u-boot-payload.lds: $(LDSCRIPT_EFI) FORCE
1626 $(call if_changed_dep,cpp_lds)
1628 # Rule to link the EFI payload which contains a stub and a U-Boot binary
1629 quiet_cmd_u-boot_payload ?= LD $@
1630 cmd_u-boot_payload ?= $(LD) $(LDFLAGS_EFI_PAYLOAD) -o $@ \
1631 -T u-boot-payload.lds arch/x86/cpu/call32.o \
1632 lib/efi/efi.o lib/efi/efi_stub.o u-boot.bin.o \
1633 $(addprefix arch/$(ARCH)/lib/,$(EFISTUB))
1635 u-boot-payload: u-boot.bin.o u-boot-payload.lds FORCE
1636 $(call if_changed,u-boot_payload)
1638 OBJCOPYFLAGS_u-boot-payload.efi := $(OBJCOPYFLAGS_EFI)
1639 u-boot-payload.efi: u-boot-payload FORCE
1640 $(call if_changed,zobjcopy)
1642 u-boot-img.bin: spl/u-boot-spl.bin u-boot.img FORCE
1643 $(call if_changed,cat)
1645 #Add a target to create boot binary having SPL binary in PBI format
1646 #concatenated with u-boot binary. It is need by PowerPC SoC having
1647 #internal SRAM <= 512KB.
1648 MKIMAGEFLAGS_u-boot-spl.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1649 -R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -T pblimage \
1650 -A $(ARCH) -a $(CONFIG_SPL_TEXT_BASE)
1652 spl/u-boot-spl.pbl: spl/u-boot-spl.bin FORCE
1653 $(call if_changed,mkimage)
1656 UBOOT_BINLOAD := u-boot.img
1658 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1659 UBOOT_BINLOAD := u-boot-with-dtb.bin
1661 UBOOT_BINLOAD := u-boot.bin
1665 OBJCOPYFLAGS_u-boot-with-spl-pbl.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO) \
1668 u-boot-with-spl-pbl.bin: spl/u-boot-spl.pbl $(UBOOT_BINLOAD) FORCE
1669 $(call if_changed,pad_cat)
1671 # PPC4xx needs the SPL at the end of the image, since the reset vector
1672 # is located at 0xfffffffc. So we can't use the "u-boot-img.bin" target
1673 # and need to introduce a new build target with the full blown U-Boot
1674 # at the start padded up to the start of the SPL image. And then concat
1675 # the SPL image to the end.
1677 OBJCOPYFLAGS_u-boot-img-spl-at-end.bin := -I binary -O binary \
1678 --pad-to=$(CONFIG_UBOOT_PAD_TO) --gap-fill=0xff
1679 u-boot-img-spl-at-end.bin: u-boot.img spl/u-boot-spl.bin FORCE
1680 $(call if_changed,pad_cat)
1682 quiet_cmd_u-boot-elf ?= LD $@
1683 cmd_u-boot-elf ?= $(LD) u-boot-elf.o -o $@ \
1684 -T u-boot-elf.lds --defsym=$(CONFIG_PLATFORM_ELFENTRY)=$(CONFIG_SYS_TEXT_BASE) \
1685 -Ttext=$(CONFIG_SYS_TEXT_BASE)
1686 u-boot.elf: u-boot.bin u-boot-elf.lds
1687 $(Q)$(OBJCOPY) -I binary $(PLATFORM_ELFFLAGS) $< u-boot-elf.o
1688 $(call if_changed,u-boot-elf)
1690 u-boot-elf.lds: arch/u-boot-elf.lds prepare FORCE
1691 $(call if_changed_dep,cpp_lds)
1693 # MediaTek's ARM-based u-boot needs a header to contains its load address
1694 # which is parsed by the BootROM.
1695 # If the SPL build is enabled, the header will be added to the spl binary,
1696 # and the spl binary and the u-boot.img will be combined into one file.
1697 # Otherwise the header will be added to the u-boot.bin directly.
1699 ifeq ($(CONFIG_SPL),y)
1700 spl/u-boot-spl-mtk.bin: spl/u-boot-spl
1702 u-boot-mtk.bin: u-boot-with-spl.bin
1703 $(call if_changed,copy)
1705 MKIMAGEFLAGS_u-boot-mtk.bin = -T mtk_image \
1706 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
1707 -n "$(patsubst "%",%,$(CONFIG_MTK_BROM_HEADER_INFO))"
1709 u-boot-mtk.bin: u-boot.bin FORCE
1710 $(call if_changed,mkimage)
1713 quiet_cmd_endian_swap = SWAP $@
1714 cmd_endian_swap = $(srctree)/tools/endian-swap.py $< $@
1716 u-boot-swap.bin: u-boot.bin FORCE
1717 $(call if_changed,endian_swap)
1719 ARCH_POSTLINK := $(wildcard $(srctree)/arch/$(ARCH)/Makefile.postlink)
1721 # Generate linker list symbols references to force compiler to not optimize
1722 # them away when compiling with LTO
1724 u-boot-keep-syms-lto := keep-syms-lto.o
1725 u-boot-keep-syms-lto_c := $(patsubst %.o,%.c,$(u-boot-keep-syms-lto))
1727 quiet_cmd_keep_syms_lto = KSL $@
1728 cmd_keep_syms_lto = \
1729 $(srctree)/scripts/gen_ll_addressable_symbols.sh $(NM) $^ > $@
1731 quiet_cmd_keep_syms_lto_cc = KSLCC $@
1732 cmd_keep_syms_lto_cc = \
1733 $(CC) $(filter-out $(LTO_CFLAGS),$(c_flags)) -c -o $@ $<
1735 $(u-boot-keep-syms-lto_c): $(u-boot-main)
1736 $(call if_changed,keep_syms_lto)
1737 $(u-boot-keep-syms-lto): $(u-boot-keep-syms-lto_c)
1738 $(call if_changed,keep_syms_lto_cc)
1740 u-boot-keep-syms-lto :=
1743 # Rule to link u-boot
1744 # May be overridden by arch/$(ARCH)/config.mk
1746 quiet_cmd_u-boot__ ?= LTO $@
1748 $(CC) -nostdlib -nostartfiles \
1749 $(LTO_FINAL_LDFLAGS) $(c_flags) \
1750 $(KBUILD_LDFLAGS:%=-Wl,%) $(LDFLAGS_u-boot:%=-Wl,%) -o $@ \
1751 -T u-boot.lds $(u-boot-init) \
1752 -Wl,--whole-archive \
1754 $(u-boot-keep-syms-lto) \
1756 -Wl,--no-whole-archive \
1757 -Wl,-Map,u-boot.map; \
1758 $(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
1760 # Note: Linking efi-x86_app64 causes a segfault in the linker at present
1761 # when using x86_64-linux-gnu-ld.bfd
1762 # For now, disable --whole-archive which makes things link, although not
1764 quiet_cmd_u-boot__ ?= LD $@
1765 cmd_u-boot__ ?= $(LD) $(KBUILD_LDFLAGS) $(LDFLAGS_u-boot) -o $@ \
1766 -T u-boot.lds $(u-boot-init) \
1767 $(if $(CONFIG_EFI_APP_64BIT),,--whole-archive) \
1769 $(if $(CONFIG_EFI_APP_64BIT),,--no-whole-archive) \
1770 $(PLATFORM_LIBS) -Map u-boot.map; \
1771 $(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
1774 quiet_cmd_smap = GEN common/system_map.o
1776 smap=`$(call SYSTEM_MAP,u-boot) | \
1777 awk '$$2 ~ /[tTwW]/ {printf $$1 $$3 "\\\\000"}'` ; \
1778 $(CC) $(c_flags) -DSYSTEM_MAP="\"$${smap}\"" \
1779 -c $(srctree)/common/system_map.c -o common/system_map.o
1781 u-boot: $(u-boot-init) $(u-boot-main) $(u-boot-keep-syms-lto) u-boot.lds FORCE
1782 +$(call if_changed,u-boot__)
1783 ifeq ($(CONFIG_KALLSYMS),y)
1785 $(call cmd,u-boot__) common/system_map.o
1788 ifeq ($(CONFIG_RISCV),y)
1789 @tools/prelink-riscv $@ 0
1792 quiet_cmd_sym ?= SYM $@
1793 cmd_sym ?= $(OBJDUMP) -t $< > $@
1794 u-boot.sym: u-boot FORCE
1795 $(call if_changed,sym)
1797 # The actual objects are generated when descending,
1798 # make sure no implicit rule kicks in
1799 $(sort $(u-boot-init) $(u-boot-main)): $(u-boot-dirs) ;
1801 # Handle descending into subdirectories listed in $(u-boot-dirs)
1802 # Preset locale variables to speed up the build process. Limit locale
1803 # tweaks to this spot to avoid wrong language settings when running
1804 # make menuconfig etc.
1805 # Error messages still appears in the original language
1807 PHONY += $(u-boot-dirs)
1808 $(u-boot-dirs): prepare scripts
1809 $(Q)$(MAKE) $(build)=$@
1812 # The "tools" are needed early
1813 $(filter-out tools, $(u-boot-dirs)): tools
1814 # The "examples" conditionally depend on U-Boot (say, when USE_PRIVATE_LIBGCC
1815 # is "yes"), so compile examples after U-Boot is compiled.
1816 examples: $(filter-out examples, $(u-boot-dirs))
1818 define filechk_uboot.release
1819 echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
1822 # Store (new) UBOOTRELEASE string in include/config/uboot.release
1823 include/config/uboot.release: include/config/auto.conf FORCE
1824 $(call filechk,uboot.release)
1827 # Things we need to do before we recursively start building the kernel
1828 # or the modules are listed in "prepare".
1829 # A multi level approach is used. prepareN is processed before prepareN-1.
1830 # archprepare is used in arch Makefiles and when processed asm symlink,
1831 # version.h and scripts_basic is processed / created.
1833 # Listed in dependency order
1834 PHONY += prepare archprepare prepare0 prepare1 prepare2 prepare3
1836 # prepare3 is used to check if we are building in a separate output directory,
1838 # 1) Check that make has not been executed in the kernel src $(srctree)
1839 prepare3: include/config/uboot.release
1840 ifneq ($(KBUILD_SRC),)
1841 @$(kecho) ' Using $(srctree) as source for U-Boot'
1842 $(Q)if [ -f $(srctree)/.config -o -d $(srctree)/include/config ]; then \
1843 echo >&2 " $(srctree) is not clean, please run 'make mrproper'"; \
1844 echo >&2 " in the '$(srctree)' directory.";\
1849 # prepare2 creates a makefile if using a separate output directory
1850 prepare2: prepare3 outputmakefile cfg
1852 prepare1: prepare2 $(version_h) $(timestamp_h) $(dt_h) \
1853 include/config/auto.conf
1854 ifeq ($(wildcard $(LDSCRIPT)),)
1855 @echo >&2 " Could not find linker script."
1859 ifeq ($(CONFIG_USE_DEFAULT_ENV_FILE),y)
1860 prepare1: $(defaultenv_h)
1862 envtools: $(defaultenv_h)
1865 archprepare: prepare1 scripts_basic
1867 prepare0: archprepare FORCE
1868 $(Q)$(MAKE) $(build)=.
1870 # All the preparing..
1873 # Generate some files
1874 # ---------------------------------------------------------------------------
1876 # Use sed to remove leading zeros from PATCHLEVEL to avoid using octal numbers
1877 define filechk_version.h
1878 (echo \#define PLAIN_VERSION \"$(UBOOTRELEASE)\"; \
1879 echo \#define U_BOOT_VERSION \"U-Boot \" PLAIN_VERSION; \
1880 echo \#define U_BOOT_VERSION_NUM $(VERSION); \
1881 echo \#define U_BOOT_VERSION_NUM_PATCH $$(echo $(PATCHLEVEL) | \
1882 sed -e "s/^0*//"); \
1883 echo \#define CC_VERSION_STRING \"$$(LC_ALL=C $(CC) --version | head -n 1)\"; \
1884 echo \#define LD_VERSION_STRING \"$$(LC_ALL=C $(LD) --version | head -n 1)\"; )
1887 # The SOURCE_DATE_EPOCH mechanism requires a date that behaves like GNU date.
1888 # The BSD date on the other hand behaves different and would produce errors
1889 # with the misused '-d' switch. Respect that and search a working date with
1890 # well known pre- and suffixes for the GNU variant of date.
1891 define filechk_timestamp.h
1892 (if test -n "$${SOURCE_DATE_EPOCH}"; then \
1893 SOURCE_DATE="@$${SOURCE_DATE_EPOCH}"; \
1895 for date in gdate date.gnu date; do \
1896 $${date} -u -d "$${SOURCE_DATE}" >/dev/null 2>&1 && DATE="$${date}"; \
1898 if test -n "$${DATE}"; then \
1899 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_DATE "%b %d %C%y"'; \
1900 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TIME "%T"'; \
1901 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TZ "%z"'; \
1902 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_EPOCH %s'; \
1907 LC_ALL=C date +'#define U_BOOT_DATE "%b %d %C%y"'; \
1908 LC_ALL=C date +'#define U_BOOT_TIME "%T"'; \
1909 LC_ALL=C date +'#define U_BOOT_TZ "%z"'; \
1910 LC_ALL=C date +'#define U_BOOT_EPOCH %s'; \
1914 define filechk_defaultenv.h
1915 ( { grep -v '^#' | grep -v '^$$' || true ; echo '' ; } | \
1917 sed -e 's/\\\x0\s*//g' | \
1922 (if test -n "$${DEVICE_TREE}"; then \
1923 echo \#define DEVICE_TREE \"$(DEVICE_TREE)\"; \
1925 echo \#define DEVICE_TREE CONFIG_DEFAULT_DEVICE_TREE; \
1929 $(version_h): include/config/uboot.release FORCE
1930 $(call filechk,version.h)
1932 $(timestamp_h): $(srctree)/Makefile FORCE
1933 $(call filechk,timestamp.h)
1935 $(dt_h): $(srctree)/Makefile FORCE
1936 $(call filechk,dt.h)
1938 $(defaultenv_h): $(CONFIG_DEFAULT_ENV_FILE:"%"=%) FORCE
1939 $(call filechk,defaultenv.h)
1941 # ---------------------------------------------------------------------------
1944 ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/boot/dts/),)
1945 dtstree := arch/$(SRCARCH)/boot/dts
1950 %.dtb: prepare3 scripts_dtc
1951 $(Q)$(MAKE) $(build)=$(dtstree) $(dtstree)/$@
1953 PHONY += dtbs dtbs_install
1954 dtbs: prepare3 scripts_dtc
1955 $(Q)$(MAKE) $(build)=$(dtstree)
1958 $(Q)$(MAKE) $(dtbinst)=$(dtstree)
1960 ifdef CONFIG_OF_EARLY_FLATTREE
1966 # Check dtc and pylibfdt, if DTC is provided, else build them
1967 PHONY += scripts_dtc
1968 scripts_dtc: scripts_basic
1969 $(Q)if test "$(DTC)" = "$(DTC_INTREE)"; then \
1970 $(MAKE) $(build)=scripts/dtc; \
1972 if ! $(DTC) -v >/dev/null; then \
1973 echo '*** Failed to check dtc version: $(DTC)'; \
1976 if test "$(call dtc-version)" -lt $(DTC_MIN_VERSION); then \
1977 echo '*** Your dtc is too old, please upgrade to dtc $(DTC_MIN_VERSION) or newer'; \
1980 if [ -n "$(CONFIG_PYLIBFDT)" ]; then \
1981 if ! echo "import libfdt" | $(PYTHON3) 2>/dev/null; then \
1982 echo '*** pylibfdt does not seem to be available with $(PYTHON3)'; \
1990 # ---------------------------------------------------------------------------
1991 quiet_cmd_cpp_lds = LDS $@
1992 cmd_cpp_lds = $(CPP) -Wp,-MD,$(depfile) $(cpp_flags) $(LDPPFLAGS) \
1993 -D__ASSEMBLY__ -x assembler-with-cpp -std=c99 -P -o $@ $<
1995 u-boot.lds: $(LDSCRIPT) prepare FORCE
1996 $(call if_changed_dep,cpp_lds)
1998 spl/u-boot-spl.bin: spl/u-boot-spl
2002 spl/u-boot-spl-dtb.bin: spl/u-boot-spl
2005 spl/u-boot-spl-dtb.hex: spl/u-boot-spl
2008 spl/u-boot-spl: tools prepare \
2009 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SPL_OF_PLATDATA),dts/dt.dtb) \
2010 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_TPL_OF_PLATDATA),dts/dt.dtb)
2011 $(Q)$(MAKE) obj=spl -f $(srctree)/scripts/Makefile.spl all
2013 spl/sunxi-spl.bin: spl/u-boot-spl
2016 spl/sunxi-spl-with-ecc.bin: spl/sunxi-spl.bin
2019 spl/u-boot-spl.sfp: spl/u-boot-spl
2022 spl/boot.bin: spl/u-boot-spl
2025 tpl/u-boot-tpl.bin: tools prepare \
2026 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SPL_OF_PLATDATA),dts/dt.dtb)
2027 $(Q)$(MAKE) obj=tpl -f $(srctree)/scripts/Makefile.spl all
2030 TAG_SUBDIRS := $(patsubst %,$(srctree)/%,$(u-boot-dirs) include)
2036 ctags -w -o ctags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
2037 -name '*.[chS]' -print`
2041 etags -a -o etags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
2042 -name '*.[chS]' -print`
2044 $(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) -name '*.[chS]' -print > \
2046 @find $(TAG_SUBDIRS) -name '*.[chS]' -type l -print | \
2047 grep -xvf - cscope.files > cscope.files.no-symlinks; \
2048 mv cscope.files.no-symlinks cscope.files
2053 grep -v '\(compiled\)\|\(\.o$$\)\|\( [aUw] \)\|\(\.\.ng$$\)\|\(LASH[RL]DI\)' | \
2056 @$(call SYSTEM_MAP,$<) > $@
2058 #########################################################################
2060 # ARM relocations should all be R_ARM_RELATIVE (32-bit) or
2061 # R_AARCH64_RELATIVE (64-bit).
2062 checkarmreloc: u-boot
2063 @RELOC="`$(CROSS_COMPILE)readelf -r -W $< | cut -d ' ' -f 4 | \
2064 grep R_A | sort -u`"; \
2065 if test "$$RELOC" != "R_ARM_RELATIVE" -a \
2066 "$$RELOC" != "R_AARCH64_RELATIVE"; then \
2067 echo "$< contains unexpected relocations: $$RELOC"; \
2071 tools/version.h: include/version.h
2072 $(Q)mkdir -p $(dir $@)
2073 $(call if_changed,copy)
2075 envtools: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2076 $(Q)$(MAKE) $(build)=tools/env
2078 tools-only: export TOOLS_ONLY=y
2079 tools-only: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2080 $(Q)$(MAKE) $(build)=tools
2082 tools-all: export HOST_TOOLS_ALL=y
2083 tools-all: envtools tools ;
2085 cross_tools: export CROSS_BUILD_TOOLS=y
2086 cross_tools: tools ;
2090 git log --no-merges U-Boot-1_1_5.. | \
2091 unexpand -a | sed -e 's/\s\s*$$//' > $@
2093 #########################################################################
2096 # Cleaning is done on three levels.
2097 # make clean Delete most generated files
2098 # Leave enough to build external modules
2099 # make mrproper Delete the current configuration, and all generated files
2100 # make distclean Remove editor backup files, patch leftover files and the like
2102 # Directories & files removed with 'make clean'
2103 CLEAN_DIRS += $(MODVERDIR) \
2104 $(foreach d, spl tpl, $(patsubst %,$d/%, \
2105 $(filter-out include, $(shell ls -1 $d 2>/dev/null))))
2107 CLEAN_FILES += include/bmp_logo.h include/bmp_logo_data.h tools/version.h \
2108 u-boot* MLO* SPL System.map fit-dtb.blob* \
2109 u-boot-ivt.img.log u-boot-dtb.imx.log SPL.log u-boot.imx.log \
2110 lpc32xx-* bl31.c bl31.elf bl31_*.bin image.map tispl.bin* \
2111 idbloader.img flash.bin flash.log defconfig keep-syms-lto.c
2113 # Directories & files removed with 'make mrproper'
2114 MRPROPER_DIRS += include/config include/generated spl tpl \
2115 .tmp_objdiff doc/output include/asm
2117 # Remove include/asm symlink created by U-Boot before v2014.01
2118 MRPROPER_FILES += .config .config.old include/autoconf.mk* include/config.h \
2119 ctags etags tags TAGS cscope* GPATH GTAGS GRTAGS GSYMS \
2120 drivers/video/fonts/*.S include/asm
2122 # clean - Delete most, but leave enough to build external modules
2124 clean: rm-dirs := $(CLEAN_DIRS)
2125 clean: rm-files := $(CLEAN_FILES)
2127 clean-dirs := $(foreach f,$(u-boot-alldirs),$(if $(wildcard $(srctree)/$f/Makefile),$f))
2129 clean-dirs := $(addprefix _clean_, $(clean-dirs))
2131 PHONY += $(clean-dirs) clean archclean
2133 $(Q)$(MAKE) $(clean)=$(patsubst _clean_%,%,$@)
2135 clean: $(clean-dirs)
2138 @find $(if $(KBUILD_EXTMOD), $(KBUILD_EXTMOD), .) $(RCS_FIND_IGNORE) \
2139 \( -name '*.[oas]' -o -name '*.ko' -o -name '.*.cmd' \
2140 -o -name '*.ko.*' -o -name '*.su' -o -name '*.pyc' \
2141 -o -name '.*.d' -o -name '.*.tmp' -o -name '*.mod.c' \
2142 -o -name '*.lex.c' -o -name '*.tab.[ch]' \
2143 -o -name '*.asn1.[ch]' \
2144 -o -name '*.symtypes' -o -name 'modules.order' \
2145 -o -name modules.builtin -o -name '.tmp_*.o.*' \
2146 -o -name 'dsdt.aml' -o -name 'dsdt.asl.tmp' -o -name 'dsdt.c' \
2147 -o -name '*.efi' -o -name '*.gcno' -o -name '*.so' \) \
2148 -type f -print | xargs rm -f
2150 # mrproper - Delete all generated files, including .config
2152 mrproper: rm-dirs := $(wildcard $(MRPROPER_DIRS))
2153 mrproper: rm-files := $(wildcard $(MRPROPER_FILES))
2154 mrproper-dirs := $(addprefix _mrproper_,scripts)
2156 PHONY += $(mrproper-dirs) mrproper archmrproper
2158 $(Q)$(MAKE) $(clean)=$(patsubst _mrproper_%,%,$@)
2160 mrproper: clean $(mrproper-dirs)
2163 @rm -f arch/*/include/asm/arch
2170 @find $(srctree) $(RCS_FIND_IGNORE) \
2171 \( -name '*.orig' -o -name '*.rej' -o -name '*~' \
2172 -o -name '*.bak' -o -name '#*#' -o -name '.*.orig' \
2173 -o -name '.*.rej' -o -name '*%' -o -name 'core' \
2174 -o -name '*.pyc' \) \
2175 -type f -print | xargs rm -f
2176 @rm -f boards.cfg CHANGELOG
2179 F=`basename $(srctree)` ; cd .. ; \
2180 gtar --force-local -zcvf `LC_ALL=C date "+$$F-%Y-%m-%d-%T.tar.gz"` $$F
2183 @echo 'Cleaning targets:'
2184 @echo ' clean - Remove most generated files but keep the config'
2185 @echo ' mrproper - Remove all generated files + config + various backup files'
2186 @echo ' distclean - mrproper + remove editor backup and patch files'
2188 @echo 'Configuration targets:'
2189 @$(MAKE) -f $(srctree)/scripts/kconfig/Makefile help
2191 @echo 'Test targets:'
2193 @echo ' check - Run all automated tests that use sandbox'
2194 @echo ' qcheck - Run quick automated tests that use sandbox'
2195 @echo ' tcheck - Run quick automated tests on tools'
2197 @echo 'Other generic targets:'
2198 @echo ' all - Build all necessary images depending on configuration'
2199 @echo ' tests - Build U-Boot for sandbox and run tests'
2200 @echo '* u-boot - Build the bare u-boot'
2201 @echo ' dir/ - Build all files in dir and below'
2202 @echo ' dir/file.[oisS] - Build specified target only'
2203 @echo ' dir/file.lst - Build specified mixed source/assembly target only'
2204 @echo ' (requires a recent binutils and recent build (System.map))'
2205 @echo ' tags/ctags - Generate ctags file for editors'
2206 @echo ' etags - Generate etags file for editors'
2207 @echo ' cscope - Generate cscope index'
2208 @echo ' ubootrelease - Output the release version string (use with make -s)'
2209 @echo ' ubootversion - Output the version stored in Makefile (use with make -s)'
2210 @echo " cfg - Don't build, just create the .cfg files"
2211 @echo " envtools - Build only the target-side environment tools"
2213 @echo 'Static analysers'
2214 @echo ' checkstack - Generate a list of stack hogs'
2215 @echo ' coccicheck - Execute static code analysis with Coccinelle'
2217 @echo 'Documentation targets:'
2218 @$(MAKE) -f $(srctree)/doc/Makefile dochelp
2220 @echo ' make V=0|1 [targets] 0 => quiet build (default), 1 => verbose build'
2221 @echo ' make V=2 [targets] 2 => give reason for rebuild of target'
2222 @echo ' make O=dir [targets] Locate all output files in "dir", including .config'
2223 @echo ' make C=1 [targets] Check all c source with $$CHECK (sparse by default)'
2224 @echo ' make C=2 [targets] Force check of all c source with $$CHECK'
2225 @echo ' make RECORDMCOUNT_WARN=1 [targets] Warn about ignored mcount sections'
2226 @echo ' make W=n [targets] Enable extra gcc checks, n=1,2,3 where'
2227 @echo ' 1: warnings which may be relevant and do not occur too often'
2228 @echo ' 2: warnings which occur quite often but may still be relevant'
2229 @echo ' 3: more obscure warnings, can most likely be ignored'
2230 @echo ' Multiple levels can be combined with W=12 or W=123'
2232 @echo 'Execute "make" or "make all" to build all targets marked with [*] '
2233 @echo 'For further info see the ./README file'
2239 $(srctree)/test/run quick
2242 $(srctree)/test/run tools
2244 # Documentation targets
2245 # ---------------------------------------------------------------------------
2246 DOC_TARGETS := xmldocs latexdocs pdfdocs htmldocs epubdocs cleandocs \
2247 linkcheckdocs dochelp refcheckdocs
2248 PHONY += $(DOC_TARGETS)
2249 $(DOC_TARGETS): scripts_basic FORCE
2250 $(Q)$(MAKE) $(build)=doc $@
2252 PHONY += checkstack ubootrelease ubootversion
2255 $(OBJDUMP) -d u-boot $$(find . -name u-boot-spl) | \
2256 $(PERL) $(src)/scripts/checkstack.pl $(ARCH)
2259 @echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
2262 @echo $(UBOOTVERSION)
2265 # ---------------------------------------------------------------------------
2266 # Single targets are compatible with:
2267 # - build with mixed source and output
2268 # - build with separate output dir 'make O=...'
2269 # - external modules
2271 # target-dir => where to store outputfile
2272 # build-dir => directory in kernel source tree to use
2274 ifeq ($(KBUILD_EXTMOD),)
2275 build-dir = $(patsubst %/,%,$(dir $@))
2276 target-dir = $(dir $@)
2278 zap-slash=$(filter-out .,$(patsubst %/,%,$(dir $@)))
2279 build-dir = $(KBUILD_EXTMOD)$(if $(zap-slash),/$(zap-slash))
2280 target-dir = $(if $(KBUILD_EXTMOD),$(dir $<),$(dir $@))
2283 %.s: %.c prepare scripts FORCE
2284 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2285 %.i: %.c prepare scripts FORCE
2286 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2287 %.o: %.c prepare scripts FORCE
2288 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2289 %.lst: %.c prepare scripts FORCE
2290 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2291 %.s: %.S prepare scripts FORCE
2292 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2293 %.o: %.S prepare scripts FORCE
2294 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2295 %.symtypes: %.c prepare scripts FORCE
2296 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2299 /: prepare scripts FORCE
2301 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2302 $(build)=$(build-dir)
2303 %/: prepare scripts FORCE
2305 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2306 $(build)=$(build-dir)
2307 %.ko: prepare scripts FORCE
2309 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2310 $(build)=$(build-dir) $(@:.ko=.o)
2311 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.modpost
2313 quiet_cmd_genenv = GENENV $@
2314 cmd_genenv = $(OBJCOPY) --dump-section .rodata.default_environment=$@ env/common.o; \
2315 sed --in-place -e 's/\x00/\x0A/g' $@
2317 u-boot-initial-env: u-boot.bin
2318 $(call if_changed,genenv)
2320 # Consistency checks
2321 # ---------------------------------------------------------------------------
2326 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/$@
2328 # FIXME Should go into a make.lib or something
2329 # ===========================================================================
2331 quiet_cmd_rmdirs = $(if $(wildcard $(rm-dirs)),CLEAN $(wildcard $(rm-dirs)))
2332 cmd_rmdirs = rm -rf $(rm-dirs)
2334 quiet_cmd_rmfiles = $(if $(wildcard $(rm-files)),CLEAN $(wildcard $(rm-files)))
2335 cmd_rmfiles = rm -f $(rm-files)
2337 # read all saved command lines
2339 cmd_files := $(wildcard .*.cmd)
2341 ifneq ($(cmd_files),)
2342 $(cmd_files): ; # Do not try to update included dependency files
2343 include $(cmd_files)
2346 endif #ifeq ($(config-targets),1)
2347 endif #ifeq ($(mixed-targets),1)
2348 endif # skip-makefile
2353 # Declare the contents of the PHONY variable as phony. We keep that
2354 # information in a variable so we can use it in if_changed and friends.